Loading...
Searching...
No Matches
SqlUtil::AbstractForeignConstraint Class Reference

the base class for foreign key constraint information More...

`#include <SqlUtil.qm.dox.h>`

Inheritance diagram for SqlUtil::AbstractForeignConstraint:
[legend]

## Public Member Functions

bool | hasTargetColumn (string col)
| Returns True if the constraint refers to the given target column.
Public Member Functions inherited from SqlUtil::AbstractColumnConstraint
| clearIndex ()
| clears any index base for the constraint
| constructor (string name, *hash< auto > cols, *string index)
| creates the object from the name and a hash of column information
| constructor (string name, Columns cols, *string index)
| creates the object from the name and a Columns object
bool | hasColumn (string cname)
| returns True if the constraint references the named column
bool | setIndexBase (string ix)
| returns True if the object supports an index property and is set, False if not
Public Member Functions inherited from SqlUtil::AbstractConstraint
abstract | clearIndex ()
| clears any index base for the constraint
| constructor (string n)
| creates the object and sets its name
bool | equal (AbstractConstraint c)
| returns True if the argument is equal to the current object, False if not
abstract string | getCreateSql (string table_name, *hash< auto > opt)
| returns a string that can be used to create the constraint in the database
string | getDisableSql (string table_name)
| returns a string that can be used to temporarily disable the constraint from the database; if disabling constraints is not supported, then the constraint will be dropped
string | getDropSql (string table_name)
| returns a string that can be used to drop the constraint from the database
string | getEnableSql (string table_name, *hash< auto > opt)
| returns a string that can be used to enable the constraint in the database; if disabling constraints is not supported, then the constraint will be dropped
string | getName ()
| returns the constraint name
abstract list< auto > | getRenameSql (string table_name, string new_name)
| returns a list of SQL strings that can be used to rename the constraint in the database
bool | hasColumn (string cname)
| returns True if the constraint references the named column
| rename (string n)
| renames the constraint
abstract bool | setIndexBase (string ix)
| returns True if the object supports an index property and is set, False if not
Public Member Functions inherited from SqlUtil::Columns
| add (string k, AbstractColumn val)
| adds the given value to the hash with the given key name
| constructor (*hash c)
| creates the object from the argument
| constructor (Columns old)
| creates a copy of the object
bool | equal (Columns cols)
| returns True if the argument has the same columns in the same order as the current object, False if not
string | getElementName ()
| returns `"column"` since this object stores column objects
AbstractIterator | getSqlColumnNameIterator ()
| returns an iterator for column SQL names
AbstractColumn | memberGate (string k)
| returns the AbstractColumn object corresponding to the key given or throws a KEY-ERROR exception
Columns | subset (softlist l)
| returns a subset of the current columns according to the list<auto> argument
AbstractColumn | take (string k)
| removes the given key from the contained hash and returns the value
Public Member Functions inherited from SqlUtil::AbstractHashContainer
| clear ()
| purges the contained data
| constructor (*hash nh)
| creates the object with the hash argument passed
| constructor (AbstractHashContainer old)
| creates a copy of the object
| copy (AbstractHashContainer old)
| creates a "deep copy" of the object
bool | empty ()
| returns True if the container is empty, False if not
*string | firstKey ()
| Returns the first key name in the contained hash or nothing if the contained hash has no keys.
abstract string | getElementName ()
| must return the name of the contained element
*hash< auto > | getHash ()
| returns the hash contained by this object
bool | hasKey (string k)
| Returns True if the key exists in the contained hash (may or may not be assigned a value), False if not.
bool | hasKeyValue (string k)
| Returns True if the key exists in the contained hash and is assigned a value, False if not.
Qore::AbstractIterator | iterator ()
| Returns a HashIterator object for the contained hash.
Qore::AbstractIterator | keyIterator ()
| Returns a HashKeyIterator object for the contained hash.
list< string > | keys ()
| Returns a list of key names of the contained hash.
*string | lastKey ()
| Returns the last key name in the contained hash or nothing if the contained hash has no keys.
bool | matchKeys (AbstractHashContainer c)
| returns True if the container argument has the same keys (in any order), False if not
bool | matchKeys (hash h1)
| returns True if the hash argument has the same keys (in any order), False if not
bool | matchKeys (list< auto > l)
| returns True if the list<auto> argument has the same list of key strings as the keys in the object (in any order), False if not
auto | memberGate (string k)
| returns the value of the given key in the contained hash if it exists, otherwise throws a `KEY-ERROR` exception
Qore::AbstractIterator | pairIterator ()
| Returns a HashPairIterator object for the contained hash.
bool | partialMatchKeys (AbstractHashContainer c)
| returns True if the container argument has at least the same keys (in any order, can have more keys), False if not
bool | partialMatchKeys (hash h1)
| returns True if the hash argument has at least the same keys (in any order, can have more keys), False if not
bool | partialMatchKeys (list< auto > l)
| returns True if the list<auto> argument has at least the same keys (in any order, can have more keys), False if not
| renameKey (string old_name, string new_name)
| renames the given key; maintains the key order
int | size ()
| Returns the number of keys in the contained hash.
abstract auto | take (string k)
| removes the given key from the contained hash and returns the value
bool | val ()
| Returns False if the contained hash has no keys, True if it does.
list< auto > | values ()
| Returns a list of values of the contained hash.

## Public Attributes

ForeignConstraintTarget | target
| a ForeignConstraintTarget object to describe the target table and columns

## Protected Member Functions

bool | equalImpl (AbstractConstraint con)
| returns True if the argument is equal to the current object, False if not
Protected Member Functions inherited from SqlUtil::AbstractConstraint
abstract bool | equalImpl (AbstractConstraint c)
| returns True if the argument is equal to the current object, False if not

## Additional Inherited Members

Protected Attributes inherited from SqlUtil::AbstractColumnConstraint
*string | index
| the index supporting the constraint
Protected Attributes inherited from SqlUtil::AbstractConstraint
string | name
| the name of the constraint
Protected Attributes inherited from SqlUtil::AbstractHashContainer
*hash | h
| the data to be contained

## Detailed Description

the base class for foreign key constraint information